; DPC.H
; Version 0.01

  IFNCONST DPC_BASE_ADDRESS
DPC_BASE_ADDRESS = $1000
  ENDIF

  IFNCONST DPC_BASE_READ_ADDRESS
DPC_BASE_READ_ADDRESS = DPC_BASE_ADDRESS
  ENDIF
  
  IFNCONST DPC_BASE_WRITE_ADDRESS
DPC_BASE_WRITE_ADDRESS = DPC_BASE_ADDRESS+$40
  ENDIF

  SEG.U DPC_REGISTERS_READ
  ORG DPC_BASE_READ_ADDRESS

; Random Numbers
RANDOM0       DS 1    ; $00
RANDOM1       DS 1    ; $01
RAMDOM2       DS 1    ; $02
RANDOM3       DS 1    ; $03

; Music Fetchers
SOUNDDRAW0    DS 1    ; $04
SOUNDDRAW1    DS 1    ; $05
SOUND0        DS 1    ; $06
SOUND1        DS 1    ; $07

; Display Data
DF0DATA       DS 1    ; $08
DF1DATA       DS 1    ; $09
DF2DATA       DS 1    ; $0A
DF3DATA       DS 1    ; $0B
DF4DATA       DS 1    ; $0C
DF5DATA       DS 1    ; $0D
DF6DATA       DS 1    ; $0E
DF7DATA       DS 1    ; $0F

; Display Data (ANDed with Flag)
DF0DATAW      DS 1    ; $10
DF1DATAW      DS 1    ; $11
DF2DATAW      DS 1    ; $12
DF3DATAW      DS 1    ; $13
DF4DATAW      DS 1    ; $14
DF5DATAW      DS 1    ; $15
DF6DATAW      DS 1    ; $16
DF7DATAW      DS 1    ; $17

; Display Data Nibbles Swapped (ANDed with Flag)
DF0DATAWSWP   DS 1    ; $18
DF1DATAWSWP   DS 1    ; $19
DF2DATAWSWP   DS 1    ; $1A
DF3DATAWSWP   DS 1    ; $1B
DF4DATAWSWP   DS 1    ; $1C
DF5DATAWSWP   DS 1    ; $1D
DF6DATAWSWP   DS 1    ; $1E
DF7DATAWSWP   DS 1    ; $1F

; Display Data Bits Reversed (ANDed with Flag)
DF0DATAWREV   DS 1    ; $20
DF1DATAWREV   DS 1    ; $21
DF2DATAWREV   DS 1    ; $22
DF3DATAWREV   DS 1    ; $23
DF4DATAWREV   DS 1    ; $24
DF5DATAWREV   DS 1    ; $25
DF6DATAWREV   DS 1    ; $26
DF7DATAWREV   DS 1    ; $27

; Display Data Rotated Right (ANDed with Flag)
DF0DATAWROR   DS 1    ; $28
DF1DATAWROR   DS 1    ; $29
DF2DATAWROR   DS 1    ; $2A
DF3DATAWROR   DS 1    ; $2B
DF4DATAWROR   DS 1    ; $2C
DF5DATAWROR   DS 1    ; $2D
DF6DATAWROR   DS 1    ; $2E
DF7DATAWROR   DS 1    ; $2F

; Display Data Rotated Left (ANDed with Flag)
DF0DATAWROL   DS 1    ; $30
DF1DATAWROL   DS 1    ; $31
DF2DATAWROL   DS 1    ; $32
DF3DATAWROL   DS 1    ; $33
DF4DATAWROL   DS 1    ; $34
DF5DATAWROL   DS 1    ; $35
DF6DATAWROL   DS 1    ; $36
DF7DATAWROL   DS 1    ; $37

; Flag Values
DF0FLAG       DS 1    ; $38
DF1FLAG       DS 1    ; $39
DF2FLAG       DS 1    ; $3A
DF3FLAG       DS 1    ; $3B
DF4FLAG       DS 1    ; $3C
DF5FLAG       DS 1    ; $3D
DF6FLAG       DS 1    ; $3E
DF7FLAG       DS 1    ; $3F

  SEG.U DPC_REGISTERS_WRITE
  ORG DPC_BASE_WRITE_ADDRESS

; Top Registers
DF0TOP        DS 1    ; $40
DF1TOP        DS 1    ; $41
DF2TOP        DS 1    ; $42
DF3TOP        DS 1    ; $43
DF4TOP        DS 1    ; $44
DF5TOP        DS 1    ; $45
DF6TOP        DS 1    ; $46
DF7TOP        DS 1    ; $47

; Bottom Registers
DF0BOT        DS 1    ; $48
DF1BOT        DS 1    ; $49
DF2BOT        DS 1    ; $4A
DF3BOT        DS 1    ; $4B
DF4BOT        DS 1    ; $4C
DF5BOT        DS 1    ; $4D
DF6BOT        DS 1    ; $4E
DF7BOT        DS 1    ; $4F

; Low Pointers
DF0LOW        DS 1    ; $50
DF1LOW        DS 1    ; $51
DF2LOW        DS 1    ; $52
DF3LOW        DS 1    ; $53
DF4LOW        DS 1    ; $54
DF5LOW        DS 1    ; $55
DF6LOW        DS 1    ; $56
DF7LOW        DS 1    ; $57

; High Pointers (lower-3 bits only)
DF0HIGH       DS 1    ; $58
DF1HIGH       DS 1    ; $59
DF2HIGH       DS 1    ; $5A
DF3HIGH       DS 1    ; $5B
DF4HIGHDRAW   DS 1    ; $5C   ; Enable/Disable Line Draw
DF5HIGHMUSIC  DS 1    ; $5D   ; Enable/Disable Music
DF6HIGHMUSIC  DS 1    ; $5E   ; Enable Disable Music
DF7HIGHMUSIC  DS 1    ; $5F   ; Enable/Disable Music

; 
MOVAMT0       DS 1    ; $60
MOVAMT1       DS 1    ; $61
MOVAMT2       DS 1    ; $62
MOVAMT3       DS 1    ; $63
MOVAMT4       DS 1    ; $64
MOVAMT5       DS 1    ; $65
MOVAMT6       DS 1    ; $66
MOVAMT7       DS 1    ; $67

; Unused 
              DS 1    ; $68
              DS 1    ; $69
              DS 1    ; $6A
              DS 1    ; $6B
              DS 1    ; $6C
              DS 1    ; $6D
              DS 1    ; $6E
              DS 1    ; $6F

; Random Number Reset
RRESET0       DS 1    ; $70
RRESET1       DS 1    ; $71
RRESET2       DS 1    ; $72
RRESET3       DS 1    ; $73
RRESET4       DS 1    ; $74
RRESET5       DS 1    ; $75
RRESET6       DS 1    ; $76
RRESET7       DS 1    ; $77

; Unused 
              DS 1    ; $78
              DS 1    ; $79
              DS 1    ; $7A
              DS 1    ; $7B
              DS 1    ; $7C
              DS 1    ; $7D
              DS 1    ; $7E
              DS 1    ; $7F

; DPC Music Notes (Low -> High)
E0  = 244
F0  = 229
F0s = 220
G0  = 204
G0s = 193

A1  = 182
A1s = 172
B1  = 162
C1  = 153
C1s = 144
D1  = 136
D1s = 129
E1  = 121
F1  = 115
F1s = 108
G1  = 102
G1s = 96

A2  = 91
A2s = 86
B2  = 82
C2  = 76            ; Middle C
C2s = 72
D2  = 69
D2s = 64
E2  = 61
F2  = 57
F2s = 54
G2  = 51
G2s = 48

A3  = 45
A3s = 43
B3  = 40
C3  = 38
C3s = 36
D3  = 34
D3s = 32
E3  = 30
F3  = 28
F3s = 26
G3  = 25
G3s = 23

A4  = 22
A4s = 21
B4  = 20
C4  = 19
C4s = 18
D4  = 17
D4s = 16
E4  = 15
F4  = 14
F4s = 13
G4  = 13
G4s = 12

CONT = 0
REST = 253
NEXT = 254
REPT = 255
